# frozen_string_literal: true

::Api::D2::UsersController.class_eval do

  private

  def user_params
    p = [:inactive_at, :email, :last_name, :first_name, :current_auth_role, :password, :password_confirmation, :profile_id, :status, :skill_ids, :superfields, :writers, :readers, :salutation, :phone_number, :cellular_telephone_number, :notification_level, :slack_id, :slack_url]
    if (params[:id].nil? || (@user.id.to_s != params[:id])) && params[:user] && params[:user][:roles]
      params[:user][:roles] = params[:user][:roles] & @user.roles.to_a
      params[:user][:roles] = nil if params[:user][:roles].to_a.size == 0
    end
    if @user.id.to_s == params[:id]
      p = p.concat([:attachment, :color])
    end
    if @user.has_role?("Manager")
      p = p.concat([:login, :trusted, :writers, :readers, :superfields, :type]).uniq
    end
    if @user.has_role?("Administrator") || @user.has_role?("Superadmin") || @user.has_role?("Supervisor")
      p = p.concat([:last_name, :first_name, :email, :login, :trusted, :password, :password_confirmation, :profile_id, :writers, :readers, :replace_user_id, :roles, :auth_roles, :superfields, :type]).uniq
    end
    ActiveModelSerializers::Deserialization.jsonapi_parse!(params, only: p, key_transform: :unaltered)
  end

end
