require 'rails_helper'
require [Hermes::Engine.root, %w[lib hermes tools specs]].flatten.join('/')

describe ::Api::D1::UsersController, type: :api do
  include Devise::Test::ControllerHelpers
  let!(:admin) { FactoryBot.create(:administrator) }

  describe 'all routes disabled' do
    before(:each) do
      authenticated_header(request, admin)
    end 

    it 'index' do
      get 'index'
      expect(response).to have_http_status(401)
    end

    it 'groups' do 
      get 'groups', params: { id: admin.id }
      expect(response).to have_http_status(401)
    end

    it 'show' do 
      get 'show', params: { id: admin.id }
      expect(response).to have_http_status(401)
    end

    it 'switch' do 
      get 'switch', params: { id: admin.id }
      expect(response).to have_http_status(401)
    end

    it 'me' do 
      get 'me'
      expect(response).to have_http_status(401)
    end

    it 'true_user' do 
      get 'true_user'
      expect(response).to have_http_status(401)
    end

    it 'ping' do 
      get 'ping'
      expect(response).to have_http_status(401)
    end

    it 'user_detail' do 
      get 'user_detail', params: { id: admin.id }
      expect(response).to have_http_status(401)
    end

    it 'locked_files' do 
      get 'locked_files', params: { id: admin.id }
      expect(response).to have_http_status(401)
    end

    it 'locked_files_hash' do 
      get 'locked_files_hash', params: { id: admin.id }
      expect(response).to have_http_status(401)
    end

    it 'create' do 
      get 'create', params: { }
      expect(response).to have_http_status(401)
    end

    it 'update' do 
      get 'update', params: { id: admin.id }
      expect(response).to have_http_status(401)
    end

    it 'destroy' do 
      get 'destroy', params: { id: admin.id }
      expect(response).to have_http_status(401)
    end

  end

end 
